*** SUMMARY STATISTICS ***

use review_data, clear

gen ban_any2 = (workprob_all>0 | barprob_all>0 | restprob_all>0)

** TABLE 1**
gen white = (race_all==1)
gen age1 = (age_g6==1)
gen inc1 = (inc2==1)
gen former2 = (smoker2==0)
replace former2 = . if smokeever==0
gen quit2 = (quit==1)
gen ed1 = (education==1)


xi: sum  smokeever smoker former quit 2 smoker2 former2 quit sex white age1 i.age_g6 ed1 i.education single child drink lfp inc1 i.inc2   adjcigprice adjfundingcap_lag adjbeer urban
xi: sum  smokeever smoker former quit 2 smoker2 former2 quit sex white age1 i.age_g6 ed1 i.education single child drink lfp inc1 i.inc2   adjcigprice adjfundingcap_lag adjbeer urban if ban_any2==0
xi: sum  smokeever smoker former quit 2 smoker2 former2 quit sex white age1 i.age_g6 ed1 i.education single child drink lfp inc1 i.inc2   adjcigprice adjfundingcap_lag adjbeer urban if ban_any2==1

sum *pct *pct*
bysort ban_any2: sum *pct *pct*

foreach b in work bar rest {
gen `b'pct = `b'_pct_cbsa if urban==1
replace `b'pct = `b'_pct_cnty if urban==0
}


** TABLE 2 **
xi: sum i.workban_nolag workprob_all i.barban_nolag restprob_all  i.restban_nolag barprob_all 
xi: sum i.workban_nolag workprob_all i.barban_nolag restprob_all  i.restban_nolag barprob_all if ban_any2==0
xi: sum i.workban_nolag workprob_all i.barban_nolag restprob_all  i.restban_nolag barprob_all if ban_any2==1



** TABLE 3**
xi: sum i.workban_nolag i.barban_nolag i.restban_nolag *prob_all  ban_any* workbanincbsa restbanincbsa barbanincbsa
xi: sum i.workban_nolag i.barban_nolag i.restban_nolag *prob_all ban_any* workbanincbsa restbanincbsa barbanincbsa if year==2001
xi: sum i.workban_nolag i.barban_nolag i.restban_nolag *prob_all  ban_any* workbanincbsa restbanincbsa barbanincbsa if year ==2009



*** FIGURE ***

bysort year: gen respondants = _N
bysort year ban_any2: gen ban_num = _N
bysort year smokeever: gen smoker_num = _N
bysort year quit: gen quit_num = _N
bysort year smoker2: gen former_num = _N

gen quit_pct = quit_num/former_num*100 if smoker2==1
gen former_pct = former_num/smoker_num*100
gen ban_pct = ban_num/respondants*100

egen quit_tag = tag(quit_pct)
egen former_tag = tag(former_pct)
egen ban_tag = tag(ban_pct)

#delimit ;
graph twoway line quit_pct year if (quit_tag==1 & quit ==0)
	|| line quit_pct year if (quit_tag==1 & quit==1)
	|| line former_pct year if (smoker2==0 & former_tag==1)
	|| line ban_pct year if (ban_tag==1 & ban_any2==1)
;
#delimit cr
graph save figure1, replace


