*** GEOCODING BAN DATA ***
** Created in 22 March 2012
** Updated 11 April 2012

**READ IN BAN FILES**

insheet using placebans.csv, clear names
sort state_abbrv area
save placebans, replace

**added geocoding to partialcountybans, wholecountybans, and statebans using fips codes from cure for the common code

insheet using partialcountybans.csv, clear names
sort fips statecode countycode placefip
save partialcountybans, replace

insheet using wholecountybans.csv, clear names
sort fips statecode countycode
gen wcworkban_date = date(wholec_workplace, "MDY")
gen wcrestban_date = date(wholec_restaurant, "MDY")
gen wcbarban_date = date(wholec_bar, "MDY")
save wholecountybans, replace

insheet using statebans.csv, clear names
gen stateworkban_date = date(state_workplace, "MDY")
gen staterestban_date = date(state_restaurants, "MDY")
gen statebarban_date = date(state_bars, "MDY")
sort statecode
save statebans, replace

***brfss geocodes***
insheet using placesinbrfss.csv, clear
duplicates drop
sort cbsa_code metrodiv_code fips statecode countycode
save brfssplaces, replace

***brfss geocodes and dates***
insheet using dates&placesinbrfss.csv, clear
duplicates drop
gen rural = (cbsa_code==.)
gen date = edate_int
sort cbsa_code metrodiv_code date
save brfss_geocodes&dates, replace

** GEOCODES FOR PLACE BANS **

insheet using spatialjoin_places_counties.csv, clear 
keep  ban  areaname class st stfips placefip name state_name state_fips cnty_fips fips
rename areaname area
rename st state_abbrv
rename stfips statecode
sort state_abbrv area
merge state_abbrv area using placebans

sort statecode placefip

gen double place_fip = statecode*100000 + placefip

gen double place_c_fip = state_fips*100000000 + cnty_fips*100000 + placefip
replace  place_c_fip = statecode*100000000 + cnty_fips*100000 + placefip if place_c_fip==.
duplicates tag place_c_fip, generate(placecounty_tag)

drop if statecode==2

save allplaces_geocoded, replace
drop if _merge~=3
rename name county_name
drop if placecounty_tag==1
drop _merge
sort place_c_fip
rename cnty_fips countycode
save placeswithbans_geocoded, replace

**Geocoding data above from ArcGIS, some codes were changed to facillitate matching to place population data

***POPULATION DATA***

** All Population, Place, County, Balance, and State Data from: http://www.census.gov/popest/data/cities/totals/2009/files/SUB-EST2009_ALL.csv
** Exception: Dunwoody GA: population from 3 yr ACS average from american fact finder using CDP

**merges & appends

insheet using all_geocodes.csv, clear
drop popcensus_2000 popbase_2000

rename  name area
rename  state statecode
rename county countycode
rename place placefip
gen fips = statecode*1000 + countycode
drop if sumlev==40
save geocodes, replace

**COUNTY**
keep if sumlev==50

forvalues y = 2000(1)2009 {
rename pop_`y' countypop_`y'
}

drop if statecode==2
drop sumlev
sort fips statecode countycode
save countypop, replace

**COUNTY BALANCE POPULATION
use geocodes, clear
keep if sumlev==157
keep if place==99990
drop sumlev cousub

forvalues y = 2000(1)2009 {
rename pop_`y' placepop_`y'
}

sort fips placefip statecode countycode 
save cntybalancepop, replace

** MERGE PC BANS
merge fips placefip statecode countycode  using partialcountybans, sort _merge(merge_pc)
save pcplacesbans_all, replace
keep if merge_pc==3
drop merge_pc
gen place_c_fip = statecode*100000000 + countycode*100000 + placefip
save pcbans_geocoded, replace


*** Towns ***
use geocodes, clear
drop if sumlev~=61
gen double place_c_fip = statecode*100000000 + countycode*100000 + cousub

forvalues y = 2000(1)2009 {
rename pop_`y' placepop_`y'
}

sort place_c_fip
save placepop2, replace

*** TOTAL PLACE POPULATION ***
use geocodes, clear
keep if sumlev==157
drop if placefip ==99990

forvalues y = 2000(1)2009 {
rename pop_`y' placepop_`y'
}

gen place_fip = statecode*100000 + placefip 
gen double place_c_fip = statecode*100000000 + countycode*100000 + placefip
sort place_fip

save placepop, replace

***Merge in bans***

merge place_c_fip using placeswithbans_geocoded, sort _merge(merge1)
save placepopban1, replace

use placepop2, clear
sort place_c_fip
merge place_c_fip using placeswithbans_geocoded, _merge(merge2)
save placepopban2, replace

append using placepopban1

drop if sumlev==.
duplicates tag place_c_fip, gen(duplicate)
drop if (duplicate==1 & sumlev==61)
replace placefip = cousub if (placefip==0 & cousub~=0)
save placepopban_all, replace

keep if (placeworkban~="" | placerestaurantban~="" | placebarban~="")
drop sumlev placecounty_tag merge1 merge2 duplicate ban cousub
save placebans_geocoded, replace

append using pcbans_geocoded
replace fips = statecode*1000 + countycode
save munibans_geocoded_wide, replace
reshape long placepop_, i(place_c_fip) j(year)

gen muniworkban = placeworkban
replace muniworkban = partialc_workplace if (partialc_workplace~="" & muniworkban=="")
gen munirestban = placerestaurantban
replace munirestban = partialc_rest if (partialc_rest~="" & munirestban=="")
gen munibarban = placebarban
replace munibarban = partialc_bar if (partialc_bar~="" & munibarban=="")
gen muniworkban_date = date(muniworkban, "MDY")
gen munirestban_date = date(munirestban, "MDY")
gen munibarban_date = date(munibarban, "MDY")
replace placepop_ = 0 if (statecode==13 & placefip==24768 & placepop==.)
sort fips year
save munibans_geocoded, replace


***merge bans to population***
use countypop, clear
keep fips countypop_2000-countypop_2009
sort fips
reshape long countypop_, i(fips) j(year)
sort fips year
merge fips year using msadata, _merge(merge_msa)
gen rural = (merge_msa==1)
gen urban = (merge_msa==3)
sort cbsa_code metrodiv_code fips
merge cbsa_code metrodiv_code fips  using brfssplaces, _merge(merge_brfss)
gen inbrfss = (merge_brfss==3)
sort fips year
merge fips using wholecountybans, _merge(merge_wc)
sort fips year
merge fips year using munibans_geocoded, _merge(merge_mb)
sort statecode
merge statecode using statebans, _merge(merge_sb)

***Cleaning data***

*** apply stringency assumption. 
*** NOTE: full county or place ban can be after stateban because the area's local government wants to either strengthen a ban and/or codify it in their system in case it will get repealed

replace wcworkban_date = . if (wcworkban_date>=stateworkban_date & wcworkban_date~=.)
replace wcrestban_date = . if (wcrestban_date>=staterestban_date & wcrestban_date~=.)
replace wcbarban_date = . if (wcbarban_date>=statebarban_date & wcbarban_date~=.)

replace muniworkban_date = . if (muniworkban_date >= stateworkban_date & muniworkban_date~=.)
replace muniworkban_date = . if (muniworkban_date >= wcworkban_date & muniworkban_date~=.)
replace munibarban_date = . if (munibarban_date >= statebarban_date & munibarban_date~=.)
replace munibarban_date = . if (munibarban_date >= wcbarban_date & munibarban_date~=.)
replace munirestban_date = . if (munirestban_date >= staterestban_date & munirestban_date~=.)
replace munirestban_date = . if (munirestban_date >= wcrestban_date & munirestban_date~=.)

*** make 2010 bans missing***
foreach b in work rest bar {
	foreach l in muni wc state {
		gen `l'`b'year = year(`l'`b'ban_date)
		replace `l'`b'ban_date = . if (`l'`b'year==2010|`l'`b'year==2011)
		}
		}

drop partialc* placeworkban placerestaurantban placebarban muniworkban munirestban munibarban merge* countyname wholec* statename class state_abbrv county_name state_name state_fips state_workplace state_restaurants state_bars muni*year wc*year state*year
rename countypop_ countypop
rename placepop_ placepop

***indicator for bans in cbsa***

sort cbsa_code metrodiv_code fips placefip
egen earliestbandate_row = rowmin(muniworkban_date munirestban_date munibarban_date wcworkban_date wcbarban_date wcrestban_date stateworkban_date staterestban_date statebarban_date)
by cbsa_code metrodiv_code: egen earliestbandate_cbsa = min(earliestbandate_row)
gen banincbsa = (earliestbandate_cbsa~=.)
gen anyban = (muniworkban_date ~=. | munirestban_date~=. | munibarban_date~=. | wcworkban_date~=. | wcbarban_date~=. | wcrestban_date ~=. | stateworkban_date ~=. | staterestban_date ~=. |  statebarban_date~=.)
replace statecode = floor(fips/1000)

sort cbsa_code metrodiv_code fips

egen multistatetag = tag(cbsa_code metrodiv_code statecode), missing
bysort cbsa_code metrodiv_code: egen multistatenum = total(multistatetag)
gen multistate_cbsa = (multistatenum>1)

sort cbsa_code metrodiv_code
egen multicountytag = tag(cbsa_code metrodiv_code fips), missing
bysort cbsa_code metrodiv_code: egen multicntynum = total(multicountytag)
gen multicnty_cbsa = (multicntynum>1)

drop multistatetag multistatenum multicountytag multicntynum
compress
save allgeocodes&bans_withbrfss, replace

keep if (banincbsa==1 | anyban==1)
save allbans, replace

***probabilities***

***make probabilities ***

***county***
keep if anyban==1
keep fips year countypop statecode place_c_fip placefip area placepop muni*date
drop if (muniworkban_date==. & munirestban_date==. & munibarban_date==.)
gen areapop = placepop
gen workbandate = muniworkban_date
gen restbandate = munirestban_date
gen barbandate = munibarban_date
gen banlevel = 1
save muniplace_append, replace
use allbans, clear
keep if anyban==1
keep fips year countypop statecode place_c_fip placefip area placepop wc*date
drop if (wcworkban_date==. & wcrestban_date==. & wcbarban_date==.)
gen areapop = countypop
gen workbandate = wcworkban_date
gen restbandate = wcrestban_date
gen barbandate = wcbarban_date
gen banlevel = 2
save municnty_append, replace
append using muniplace_append
save dataforplaceprobs, replace

foreach b in work bar rest{
	keep fips placefip year countypop placepop area muni`b'ban_date wc`b'ban_date `b'bandate areapop banlevel
	drop if (`b'bandate==.)
	gen `b'year = year(`b'bandate)
	drop if (year<`b'year)
	duplicates drop fips year areapop if banlevel==2, force
	
	sort fips year `b'bandate, stable
	by fips: egen highestbanlevel = max(banlevel)
	
	sort fips year 	`b'bandate, stable
	egen originalfullban = tag(fips banlevel) if banlevel==2
	gen fullban = 1 if originalfullban==1
	gen fullbandate = `b'bandate if fullban==1
	by fips: carryforward fullban, carryalong (fullbandate) replace
	replace fullban = 0 if fullban==.
	replace fullbandate = 0 if fullbandate==. 
	drop if (fullban==1 & banlevel<2)
	
	sort fips year `b'bandate placefip, stable
	egen firstbantag = tag(fips)
	egen originalbantag = tag(fips year)
	gen oldbans = (`b'year<year)
	by fips year `b'bandate: gen samedate = (`b'bandate[_n] == `b'bandate[_n-1] | `b'bandate[_n]==`b'bandate[_n+1])
	
	by fips: gen morestringent = (banlevel[_n] > banlevel[_n-1] ==1 & fips[_n] == fips[_n-1])
	
	sort fips year oldbans, stable
	by fips year oldbans: egen double areapop2 = total(areapop) if(morestringent==0 & oldbans==1)
	expand 2 if (morestringent==1 & originalbantag==1)
	duplicates tag fips year `b'bandate morestringent originalbantag areapop areapop2, gen(dbl)
	replace originalbantag = 0 if (dbl==1 & fips[_n]==fips[_n-1] & year[_n]==year[_n-1])
	replace morestringent = 0 if (dbl==1 & fips[_n]==fips[_n+1] & year[_n]==year[_n+1])
	
	gen areapop_all = areapop2 if morestringent~=1
	replace areapop_all = areapop if areapop_all==.
	duplicates drop firs year placefip areapop_all morestringent if originalbantag==0, force
	sort fips year `b'bandate, stable
	by fips year `b'bandate: egen double areapop3 = total(areapop) if (samedate==1 & oldbans==0 & morestringent==0)
	replace areapop_all = areapop3 if areapop3~=.
	egen poptag = tag(areapop_all `b'bandate)
	drop if (poptag==0 & originalbantag==0)
	duplicates tag (fips areapop_all year), gen(dbl2)
	drop if (dbl2>0 & originalbantag==0)
	drop if (originalbantag==0 & oldbans==1 & morestringent==0)
	
	sort fips year `b'bandate, stable
	bysort fips year: gen total_area = _N
	
	gen place`b'_prob = areapop_all/countypop
	
	gen cnty`b'_prob = place`b'_prob if (total_area==1 & morestringent==0)
	replace cnty`b'_prob = place`b'_prob if (firstbantag==1 & cnty`b'_prob==.)
	replace cnty`b'_prob = place`b'_prob if (originalbantag==1 & cnty`b'_prob==.)
	replace cnty`b'_prob = place`b'_prob if (place`b'_prob==1 & cnty`b'_prob==.)
	
	sort fips year `b'bandate, stable
	by fips year: replace cnty`b'_prob = place`b'_prob + cnty`b'_prob[_n-1] if (cnty`b'_prob[_n-1]~=. & morestringent==0)

	gen cnty`b'probdate = `b'bandate
	replace cnty`b'probdate = 14610 if (originalbantag == 1 & firstbantag ==0 & year==2000)
	replace cnty`b'probdate = 14976 if (originalbantag == 1 & firstbantag ==0 & year==2001)
	replace cnty`b'probdate = 15341 if (originalbantag == 1 & firstbantag ==0 & year==2002)
	replace cnty`b'probdate = 15706 if (originalbantag == 1 & firstbantag ==0 & year==2003)
	replace cnty`b'probdate = 16071 if (originalbantag == 1 & firstbantag ==0 & year==2004)
	replace cnty`b'probdate = 16437 if (originalbantag == 1 & firstbantag ==0 & year==2005)
	replace cnty`b'probdate = 16802 if (originalbantag == 1 & firstbantag ==0 & year==2006)
	replace cnty`b'probdate = 17167 if (originalbantag == 1 & firstbantag ==0 & year==2007)
	replace cnty`b'probdate = 17532 if (originalbantag == 1 & firstbantag ==0 & year==2008)
	replace cnty`b'probdate = 17898 if (originalbantag == 1 & firstbantag ==0 & year==2009)	


	duplicates tag fips cnty`b'probdate, gen(duplicatedate)
	drop if (duplicatedate>0 & originalbantag==1)
	sort fips cnty`b'probdate
	save cntyban`b'_probs_all, replace
	outsheet fips year `b'bandate cnty`b'probdate cnty`b'_prob using cbsa`b'_probs_all.csv, comma replace
	keep fips year `b'bandate cnty`b'probdate cnty`b'_prob
	gen date = cnty`b'probdate
	save cnty`b'_probs_short, replace
	use dataforplaceprobs, clear
	}
	
*** cbsas ***
use allbans, clear
keep if anyban==1
keep if urban==1
keep cbsa_code metrodiv_code statecode countycode fips year cbsacntypop cbsastatepop placepop *date placefip msapop multi*cbsa

sort cbsa_code metrodiv_code statecode


egen multiplacetag = tag(cbsa_code metrodiv_code placefip), missing
bysort cbsa_code metrodiv_code: egen multiplacenum = total(multiplacetag)
gen multiplace_cbsa = (multiplacenum>1)

drop multi*tag multi*num

save cbsabans, replace

***set up data for stacking***
*** SET UP PLACES ***

keep cbsa_code metrodiv_code multi*cbsa  cbsa*pop  year statecode fips placefip  placepop msapop muniworkban_date munibarban_date munirestban_date
drop if (muniworkban_date==. & munirestban_date==. & munibarban_date==.)
gen double placeid = cbsa_code*100000000000000000 + metrodiv_code*10000000000 + placefip
replace placeid = cbsa_code*100000000000000000 + placefip if placeid==.
replace placepop = 0 if placepop==.
gen placeworkyear = year(muniworkban_date)
gen placerestyear = year(munirestban_date)
gen placebaryear = year(munibarban_date)
bysort cbsa_code metrodiv_code placefip year: egen totalplacepop = total(placepop)
rename placepop placepop_part
rename totalplacepop placepop
sort cbsa_code metrodiv_code  placefip year fips
egen droptag = tag(cbsa_code metrodiv_code placefip year), missing
drop if droptag==0

keep cbsa_code metrodiv_code multicnty_cbsa multistate_cbsa cbsa*pop fips placefip year statecode msapop placepop muniworkban_date munibarban_date munirestban_date  placeid placeworkyear  placerestyear  placebaryear 
rename placeid id
gen workbandate =  muniworkban_date
gen restbandate = munirestban_date
gen barbandate = munibarban_date
gen areapop = placepop
gen workyear =  placeworkyear 
gen baryear = placebaryear
gen restyear = placerestyear
gen banlevel = 1
gen banlevel2 = 1
save placeprobs_append, replace

***SET UP COUNTIES ***

use cbsabans, clear
keep cbsa_code metrodiv_code multicnty_cbsa  multistate_cbsa cbsa*pop  cbsa_code  fips year statecode cbsacntypop msapop wcworkban_date wcbarban_date wcrestban_date
gen double countyid = cbsa_code*100000000000000000 + metrodiv_code*10000000000  + fips*100000
replace countyid = cbsa_code*100000000000000000 + fips*100000 if countyid==.
gen wcworkyear = year(wcworkban_date)
gen wcrestyear = year(wcrestban_date)
gen wcbaryear = year(wcbarban_date)
sort cbsa_code metrodiv_code year fips
gen areapop = cbsacntypop
duplicates drop countyid year , force

save counties_cbsas, replace

keep cbsa_code metrodiv_code multicnty_cbsa  multistate_cbsa fips year statecode msapop cbsacntypop wcworkban_date wcbarban_date wcrestban_date  countyid wcworkyear  wcrestyear  wcbaryear  areapop
rename countyid id
gen workbandate =  wcworkban_date
gen restbandate = wcrestban_date
gen barbandate = wcbarban_date
gen workyear = wcworkyear
gen restyear = wcrestyear
gen baryear = wcbaryear
gen banlevel = 2
gen banlevel2 = 2 if (multicnty_cbsa==1)
replace banlevel2 = 3 if (multicnty_cbsa==0)
save countyprobs_append, replace

*** SET UP STATES ***

use cbsabans, clear
keep cbsa_code metrodiv_code multicnty_cbsa  multistate_cbsa cbsa*pop  cbsa_code multistate_cbsa fips year statecode cbsacntypop msapop stateworkban_date statebarban_date staterestban_date
gen double stateid = cbsa_code*100000000000000000 + metrodiv_code*10000000000  + statecode*10000000000
replace stateid = cbsa_code*100000000000000000 + statecode*10000000000 if stateid==.
gen stateworkyear = year(stateworkban_date)
gen staterestyear = year(staterestban_date)
gen statebaryear = year(statebarban_date)
sort cbsa_code metrodiv_code year statecode
gen areapop = cbsastatepop
sort cbsa_code metrodiv_code statecode year fips
egen droptag = tag(cbsa_code metrodiv_code statecode year), missing
drop if droptag==0
save states_cbsas, replace

keep cbsa_code metrodiv_code multicnty_cbsa  multistate_cbsa fips year statecode msapop  stateworkban_date statebarban_date staterestban_date  stateid stateworkyear  staterestyear  statebaryear areapop
rename stateid id
gen workbandate =  stateworkban_date
gen restbandate = staterestban_date
gen barbandate = statebarban_date
gen workyear = stateworkyear
gen restyear = staterestyear
gen baryear = statebaryear
gen banlevel = 3
gen banlevel2 = 4 if (multistate_cbsa==1)
replace banlevel2 = 5 if (multistate_cbsa==0)
save stateprobs_append, replace
append using countyprobs_append
append using placeprobs_append
gen metrodiv_code2 = metrodiv_code
replace metrodiv_code2 = 0 if metrodiv_code ==.
gen placefip2 = 0 if placefip==.
replace placefip2 = placefip if placefip2==.
egen id2 = concat(cbsa_code metrodiv_code2 fips placefip2), punct("-")
save cbsa_probs_stacked, replace

foreach b in work bar rest {
	keep fips year statecode placefip multicnty_cbsa  `b'bandate multistate_cbsa multicnty_cbsa   cbsa_code metrodiv_code *pop id id2 `b'year banlevel `b'ban banlevel2
	drop if `b'bandate==.
	drop if year<`b'year
	
	sort cbsa_code metrodiv_code year `b'bandate, stable
	by cbsa_code metrodiv_code: egen highestbanlevel = max(banlevel)
	sort cbsa_code metrodiv_code year banlevel `b'bandate
	*drop if (`b'year<2000 & banlevel<highestbanlevel)

	sort cbsa_code metrodiv_code fips

	egen multistatetag = tag(cbsa_code metrodiv_code statecode), missing
	bysort cbsa_code metrodiv_code: egen multistatenum = total(multistatetag)
	gen multistate_cbsa2 = (multistatenum>1)

	sort cbsa_code metrodiv_code, stable
	egen multicountytag = tag(cbsa_code metrodiv_code fips), missing
	by cbsa_code metrodiv_code: egen multicntynum = total(multicountytag)
	gen multicnty_cbsa2 = (multicntynum>1)
	
	sort cbsa_code metrodiv_code year `b'bandate, stable

	egen originalstatebandate = tag(cbsa_code metrodiv_code banlevel) if (banlevel==3 & multistate_cbsa2==0), missing
	
	gen stateban = 1 if originalstatebandate==1
	gen originalstatedate = `b'bandate if originalstatebandate==1
	by cbsa_code metrodiv_code: carryforward stateban, carryalong(originalstatedate) replace
	replace stateban = 0 if stateban==.
	replace originalstatedate = 0 if originalstatedate==.
	drop if (stateban == 1 & originalstatedate>=`b'bandate & banlevel<3 & multistate_cbsa2==0)
	drop if (stateban ==1 & `b'bandate>=originalstatebandate & banlevel<3 & multistate_cbsa2==0)
	
	sort cbsa_code metrodiv_code  statecode year `b'bandate, stable
	egen originalmultistatedate = tag(cbsa_code metrodiv_code statecode banlevel) if (banlevel == 3 & multistate_cbsa2==1), missing
	gen msban = 1 if originalmultistatedate==1
	gen msdate = `b'bandate if msban==1 
	gen msstate = statecode if msban==1
	sort cbsa_code metrodiv_code  statecode year `b'bandate, stable
	by cbsa_code metrodiv_code statecode: carryforward msban, carryalong(msdate msstate) replace
	replace msban = 0 if msban ==.
	replace msdate = 0 if msdate ==.
	replace msstate = 0 if msstate ==.

	drop if (msban==1 & statecode == msstate & msdate>`b'bandate & banlevel<3)
	
	sort cbsa_code metrodiv_code fips year `b'bandate, stable
	
	egen originalwcbandate = tag(cbsa_code metrodiv_code fips banlevel) if (banlevel==2 & multicnty_cbsa2==0), missing
	gen wcban = 1 if originalwcbandate==1
	gen wcdate = `b'bandate if wcban==1
	gen wcfips = fips if wcban==1
	by cbsa_code metrodiv_code: carryforward wcban, carryalong(wcdate wcfips) replace
	replace wcban =0 if wcban==.
	replace wcdate = 0 if wcdate==.
	replace wcfips = 0 if wcfips==.
	drop if (wcban==1 & wcdate>`b'bandate & banlevel<2 & fips==wcfips)
	
	sort cbsa_code metrodiv_code  fips year `b'bandate, stable
	egen originalmulticntyban = tag(cbsa_code metrodiv_code fips banlevel) if (banlevel == 2 & multicnty_cbsa2==1), missing
	gen mcban = 1 if originalmulticntyban==1 
	gen mcfips = fips if mcban==1
	gen mcdate = `b'bandate if mcban==1
	by cbsa_code metrodiv_code fips: carryforward mcban, carryalong(mcfips mcdate) replace
	replace mcban = 0 if mcban ==.
	replace mcfips = 0 if mcfips==.
	replace mcdate = 0 if mcdate==.
	drop if (mcban==1 & fips == mcfips & mcdate>`b'bandate & banlevel<2)
	
	sort cbsa_code metrodiv_code  year `b'bandate, stable

	gen oldbans = (`b'year<year)
	sort cbsa_code metrodiv_code year `b'bandate, stable
	by cbsa_code metrodiv_code year `b'bandate: gen samedate = (`b'bandate[_n] == `b'bandate[_n-1] | `b'bandate[_n] == `b'bandate[_n+1])
	
	**more stringent dummy**
	sort cbsa_code metrodiv_code fips year `b'bandate, stable
	by cbsa_code metrodiv_code: gen morestringent = (banlevel[_n] == 2 & banlevel[_n-1] ==1 & fips[_n] == fips[_n-1])
	replace morestringent = 1 if (banlevel[_n] == 3 & banlevel[_n-1]<3 & statecode[_n]==statecode[_n-1])	
	sort cbsa_code metrodiv_code statecode year `b'bandate, stable
	replace morestringent = 1 if (banlevel[_n] == 3 & banlevel[_n-1]<3 & statecode[_n]==statecode[_n-1])	

	**less stringent dummy**
	gen highestbanyear = `b'year if (morestringent==1)
	sort cbsa_code metrodiv_code year highestbanyear, stable
	by cbsa_code metrodiv_code year: carryforward highestbanyear, replace
	gen lessstringent = (year==highestbanyear & banlevel<highestbanlevel)
	replace lessstringent = 1 if (year==highestbanyear & banlevel==highestbanlevel & multicnty_cbsa2==1)
	
	sort cbsa_code metrodiv_code year `b'bandate fips, stable
	egen firstbantag = tag(cbsa_code metrodiv_code), missing
	egen originalbantag = tag(cbsa_code metrodiv_code  year), missing
	sort cbsa_code metrodiv_code year oldbans, stable
	by cbsa_code metrodiv_code year oldbans: egen double areapop2 = total(areapop) if (areapop<msapop & morestringent==0 & oldbans==1)
	expand 2 if (lessstringent==1 & originalbantag==1)
	duplicates tag cbsa_code metrodiv_code year `b'bandate lessstringent originalbantag areapop areapop2, gen(dbl)
	sort dbl cbsa_code metrodiv_code year, stable
	gen lessstringentpop = areapop if (dbl==1 & cbsa_code[_n]==cbsa_code[_n-1] & metrodiv_code[_n] == metrodiv_code[_n-1] & year[_n]==year[_n-1])
	replace originalbantag = 0 if (dbl==1 & cbsa_code[_n]==cbsa_code[_n-1] & metrodiv_code[_n] == metrodiv_code[_n-1] & year[_n]==year[_n-1])
	replace lessstringent = 0 if (dbl==1 & cbsa_code[_n]==cbsa_code[_n+1] & metrodiv_code[_n] == metrodiv_code[_n+1] & year[_n]==year[_n+1])
	replace lessstringentpop = areapop if lessstringent==1

	sort cbsa_code metrodiv_code year `b'bandate, stable

	gen areapop_all = areapop2
	replace areapop_all = areapop if (areapop_all==.)
	replace areapop_all = lessstringentpop if lessstringentpop~=.
	***replace in new observation
	
	duplicates drop id year areapop_all lessstringent if (originalbantag==0), force
	
	sort cbsa_code metrodiv_code year `b'bandate, stable
	by cbsa_code metrodiv_code year `b'bandate: egen double areapop3 = total(areapop) if (samedate==1 & oldbans==0 & morestringent==0 & lessstringent==0)
	replace areapop_all = areapop3 if areapop3~=.
	egen poptag = tag(areapop_all `b'bandate)
	
	drop if (poptag==0 & originalbantag==0)
	duplicates tag (cbsa_code metrodiv_code areapop_all year), gen(dbl2)
	drop if (dbl2>0 & originalbantag==0)
	drop if (originalbantag ==0 & oldbans==1 & lessstringent==0 & morestringent==0)
	drop if (originalbantag ==0 & lessstringent==1 & multicnty_cbsa2==0)
	
	sort cbsa_code metrodiv_code  year `b'bandate, stable
	bysort cbsa_code metrodiv_code year: gen total_area = _N	
	by cbsa_code metrodiv_code year: egen total_oldbans = total(oldbans), missing
	gen newbans = total_area - total_oldbans
	
	sort cbsa_code metrodiv_code year `b'bandate, stable 

	gen `b'_prob = areapop_all/msapop
	gen cbsa`b'_prob = `b'_prob if (total_area==1 & morestringent==0 & lessstringent==0)
	replace cbsa`b'_prob = `b'_prob if (firstbantag==1 & cbsa`b'_prob==.)
	replace cbsa`b'_prob = `b'_prob if (originalbantag==1 & cbsa`b'_prob==.)	
	replace cbsa`b'_prob = `b'_prob if (`b'_prob==1 & cbsa`b'_prob==.)
	
	sort cbsa_code metrodiv_code year `b'bandate fips, stable
	by cbsa_code metrodiv_code year: replace cbsa`b'_prob  = cbsa`b'_prob[_n-1] + `b'_prob[_n] if (cbsa`b'_prob==. & lessstringent==0 & morestringent==0 & `b'_prob[_n]~=1)
	
	***dealing with more/less stringent
	sort cbsa_code metrodiv_code year

	egen multistatetag2 = tag(cbsa_code metrodiv_code statecode year), missing
	bysort cbsa_code metrodiv_code year: egen multistatenum2 = total(multistatetag2)
	gen multistate_cbsa3 = (multistatenum2>1)

	replace cbsa`b'_prob = `b'_prob if (morestringent==1 & multicnty_cbsa2==0)
	replace cbsa`b'_prob = `b'_prob if (morestringent==1 & multistate_cbsa3==0 & multistate_cbsa2==1)
	
	sort cbsa_code metrodiv_code year `b'bandate fips, stable
	by cbsa_code metrodiv_code year: replace cbsa`b'_prob = `b'_prob + cbsa`b'_prob[_n-1] if (cbsa`b'_prob==. & oldbans~=1 & lessstringent==1)
	replace cbsa`b'_prob = `b'_prob if (morestringent==1 & lessstringent[_n-1]==0)
	replace cbsa`b'_prob = 1 if (morestringent==1 & cbsa`b'_prob[_n+1]==1 & year[_n]<year[_n+1])
	replace cbsa`b'_prob = 1 if (lessstringent==0 & cbsa`b'_prob[_n-1]==1 & year[_n]>year[_n-1])
	by cbsa_code metrodiv_code year: gen lessstringentprob = cbsa`b'_prob[_n-1] - `b'_prob if (lessstringent==1 & lessstringent[_n-1]==0 & statecode[_n]==statecode[_n-1])
	
	sort cbsa_code metrodiv_code year morestringent banlevel, stable
	by cbsa_code metrodiv_code year: replace lessstringentprob = `b'_prob[_n] + lessstringentprob[_n-1] if(lessstringentprob[_n-1]~=. & lessstringent==1 & morestringent==0)
	by cbsa_code metrodiv_code year: replace lessstringentprob = `b'_prob + lessstringentprob[_n-1] - `b'_prob[_n-1] if (lessstringentprob[_n-1]~=. & lessstringent==1 & morestringent==1 & statecode[_n]==statecode[_n-1])
	
	***multistate, multilevel, same state is entry before
	replace cbsa`b'_prob = `b'_prob + lessstringentprob[_n-1] if (cbsa`b'_prob==. & morestringent==1 & banlevel[_n]>banlevel[_n-1] & statecode[_n]==statecode[_n-1] & multistate_cbsa3==1)
	replace cbsa`b'_prob = `b'_prob + `b'_prob[_n-1] if (cbsa`b'_prob==. & morestringent==1 & banlevel[_n]==3 & banlevel[_n-1]==3 & statecode[_n]~=statecode[_n-1] & multistate_cbsa3==1)
	drop if (lessstringent==1 & cbsa`b'_prob==.)
	
	
	****JAN 1 DATES***
	gen cbsa`b'probdate = `b'bandate if (firstbantag==1 | originalbantag==0)
	replace cbsa`b'probdate = 14610 if (originalbantag==1 & firstbantag==0 & year==2000)
	replace cbsa`b'probdate = 14976 if (originalbantag==1 & firstbantag==0 & year==2001)
	replace cbsa`b'probdate = 15341 if (originalbantag==1 & firstbantag==0 & year==2002)
	replace cbsa`b'probdate = 15706 if (originalbantag==1 & firstbantag==0& year==2003)
	replace cbsa`b'probdate = 16071 if (originalbantag==1 & firstbantag==0 & year==2004)
	replace cbsa`b'probdate = 16437 if (originalbantag==1 & firstbantag==0 & year==2005)
	replace cbsa`b'probdate = 16802 if (originalbantag==1 & firstbantag==0 & year==2006)
	replace cbsa`b'probdate = 17167 if (originalbantag==1 & firstbantag==0 & year==2007)
	replace cbsa`b'probdate = 17532 if (originalbantag==1 & firstbantag==0 & year==2008)
	replace cbsa`b'probdate = 17898 if (originalbantag==1 & firstbantag==0 & year==2009)
	
	duplicates tag cbsa_code metrodiv_code cbsa`b'probdate, gen(duplicatedate)
	drop if (duplicatedate>0 & originalbantag==1)
	
	sort cbsa_code metrodiv_code cbsa`b'probdate
	save cbsaban`b'_probs_all, replace
	
	***DROP THINGS THEN SAVE***
	outsheet cbsa_code metrodiv_code year `b'bandate cbsa`b'probdate cbsa`b'_prob using cbsa`b'_probs_all.csv, comma replace
	keep cbsa_code metrodiv_code year `b'bandate cbsa`b'probdate cbsa`b'_prob
	gen date = cbsa`b'probdate
	save cbsa`b'_probs_short, replace
	use cbsa_probs_stacked, clear
}

***merge probabilities  to brfss dates***
foreach b in work bar rest {
	use cbsa`b'_probs_short, clear
	sort cbsa_code metrodiv_code date
	merge cbsa_code metrodiv_code date using brfss_geocodes&dates, _merge(merge_brfss1)
	drop if rural==1
	gen `b'probcbsa = cbsa`b'_prob
	sort cbsa_code metrodiv_code date
	by cbsa_code metrodiv_code: carryforward `b'probcbsa, replace
	replace `b'probcbsa = 0 if `b'probcbsa==.
	drop if edate_int==.
	keep cbsa_code metrodiv_code edate_int `b'probcbsa
	duplicates drop
	sort cbsa_code metrodiv_code edate_int
	save cbsa`b'_prob_brfssdate, replace
	}

use brfss_geocodes&dates, clear
sort fips date
save, replace


foreach b in work bar rest {
	use cnty`b'_probs_short, clear
	gen date = cnty`b'probdate
	sort fips date
	merge fips date using brfss_geocodes&dates,  _merge(merge_brfss1)
	gen `b'probcnty = cnty`b'_prob
	sort fips date
	by fips: carryforward `b'probcnty, replace
	replace `b'probcnty = 0 if `b'probcnty==.
	drop if edate_int==.
	keep fips date edate_int `b'probcnty
	duplicates drop
	sort fips edate_int
	save cnty`b'_prob_brfssdate, replace
	}


***GET BAN DATES FOR EACH TYPE OF BAN FOR BRFSS ONLY***
foreach p in wc muni state {
use allbans, clear
keep if inbrfss==1
keep fips  statecode countycode `p'*date
drop if (`p'workban_date==. & `p'restban_date==. & `p'barban_date==.)
duplicates drop
sort fips statecode countycode
save `p'bans2, replace
}

drop fips  countycode
duplicates drop
sort statecode
save statebans2, replace

foreach b in work rest bar {
use munibans2, clear
keep fips statecode countycode muni`b'ban_date
sort fips muni`b'ban_date, stable
egen earliest = tag(fips)
keep if earliest==1
drop earliest
sort fips statecode countycode
save muni`b'bans, replace
} 

merge fips statecode countycode using munirestbans, _merge(merge_munirest)
sort fips statecode countycode
merge fips statecode countycode using muniworkbans, _merge(merge_muniwork)
sort fips statecode countycode
merge fips statecode countycode using wcbans2, _merge(merge_wc)
drop merge*
sort fips statecode countycode
save countybans_all, replace
