***BRFSS Set-Up***

***Cigarette Price Data***

insheet using costpack.csv, clear
reshape long costpack_av, i(state statecode) j(year)
sort state statecode year
save costpack, replace

**spending**
insheet using spending.csv, clear
keep year statecode fund_cap adjfund_cap
compress
sort statecode  year
save spending, replace
insheet using population.csv , clear
reshape long pop, i(state statecode) j(year)
compress
sort statecode year
save population, replace
insheet using  spending2.csv, clear
reshape long statespending, i(state statecode) j(year)
sort statecode year
merge statecode year using population.dta, _merge(spend08merge)
gen fund_cap = (statespending*1000000)/pop
rename statespending totalfund_state
append using spending
collapse fund_cap, by(statecode year)
replace fund_cap = 0 if (statecode==45 & year==2009)
sort statecode year
tsset statecode year
gen fundcap_lag=L.fund_cap
drop if year<2000
save spending, replace

*** ACCRA Price Data: proprietary, data are not included in online download from Fed website, will merge fully adjusted price data later in code ***
**beer**
*insheet using ACCRAprices.csv, clear
*drop if year==.
*drop if statecode>56
*keep year statecode beer
*collapse (mean) beer, by(year statecode)
*sort year statecode
*save state_beer_annual, replace

**accra composite index**
*insheet using ACCRAcomposite.csv, clear
*drop if year==.
*drop if statecode>56
*collapse (mean) composite_index, by (year  statecode)
*sort year statecode
*tsset statecode year
*gen index_lag=L.composite_index
*save state_composite_annual, replace


**BRFSS**

* CHANGE WORKING DIRECTORY TO "Files for BRFSS Import" FOLDER*
forvalues x=2001(1)2009 {
	clear
	infile using BRFS`x'dict.dct
	drop if CTYCODE==""
	drop if CTYCODE=="777"
	drop if CTYCODE=="999" 
	destring IMONTH, replace
	destring IDAY, replace
	destring IYEAR, replace
	drop if AGE>=50
	compress
	save "/Users/KateV/Desktop/Honors_Final/BRFS`x'_working", replace
	}

cd "/Users/KateV/Desktop/Honors_Final"
use BRFS2001_working, clear
forvalues x=2002(1)2009 {
	append using BRFS`x'_working
	}
gen ID= _n
tostring ID, replace
save, replace
gen edate_int = mdy(IMONTH, IDAY, IYEAR)
gen statecode = real(_STATE)
gen countycode = real(CTYCODE)
gen fips = statecode*1000+countycode
drop if statecode>56
rename IYEAR year
replace countycode=86 if fips==12025
replace fips = 12086 if fips==12025
replace fips = 51005 if fips==51560
replace countycode = 5 if fips==51005
save BRFS_working_appended, replace

gen age_all = AGE
replace age_all = _IMPAGE if (age_all<10)
drop if age_all<10
drop if age_all>=50

gen race_all = RACE
replace race_all = 1 if RACE2==1 
**white
replace race_all = 2 if RACE2==2 
**black
replace race_all = 6 if (RACE2==3 | RACE2==4) 
**asian/pi
replace race_all = 7 if (RACE2==5) 
**am ind
replace race_all = 3 if (race_all==4 | race_all==5 | RACE2==8)  
**hisp
replace race_all=8 if (RACE2==6 | RACE2==7) 
**other
replace race_all=. if (RACE2==9 | race_all==99 | race_all==9)
replace race_all=. if race_all==77

gen age_g6 = 2 if age_all<=25
replace age_g6 = 3 if (age_all>25)
replace age_g6 = 4 if age_all>30
replace age_g6 = 5 if age_all>35
replace age_g6 = 6 if age_all>40
replace age_g6 = 1 if age_all>45

gen education = 1 if EDUCA<=3
replace education = 2 if EDUCA==4
replace education = 3 if EDUCA==5
replace education = 4 if EDUCA==6

replace EMPLOY = . if EMPLOY==9
gen lfp = 1 if EMPLOY<=2
replace lfp = 0 if (lfp==. & EMPLOY~=.)

replace INCOME2 = . if INCOME2>8
rename INCOME2 income
gen inc2 = 1 if income<=3
replace inc2 = 2 if income>3
replace inc2 = 3 if income>5
replace inc2 = 4 if income==8

replace MARITAL = . if MARITAL==9
gen single = (MARITAL ~=1 & MARITAL~=6)
replace single = . if MARITAL==.

gen smokeever = (_SMOKER2<=3 | _SMOKER3<=3)
gen smoker = (_SMOKER2<=2|_SMOKER3<=2)
gen smoker2 = 1 if smoker==1
replace smoker2 = 0 if (smokeever==1 & smoker==0)
gen former = (_SMOKER2==3 | _SMOKER3==3) if year~=1995
gen smokefreq = 0 if (SMOKEDAY==3 | SMOKDAY2==3)
replace smokefreq = 1 if (SMOKEDAY==2 | SMOKDAY2==2)
replace smokefreq = 2 if (SMOKEDAY==1 | SMOKDAY2==1)
gen quit = 1 if (STOPSMK2==1)
replace quit = 0 if (STOPSMK2==2)

gen drink = 1 if DRNKANY4==1
replace drink = 0 if DRNKANY4==2
replace drink = 1 if (DRNKANY3==1 & drink==. & DRNKANY3 ~=.)
replace drink = 0 if (DRNKANY3~=1 & drink==. & DRNKANY3~=.)
replace drink = 1 if (ALCDAYS<777 & year==2001)
replace drink = 0 if (ALCDAYS==888 & year==2001)

gen sex = SEX-1

gen child = 1 if CHILDREN<50
replace child = . if CHILDREN==99
replace child = 0 if CHILDREN==88

* drops/keeps
keep age_all age_g6 race_all statecode countycode income inc2 single lfp drink education statecode year  sex edate_int fips child ID  smokeever smoker smoker2 former smokefreq quit
drop if countycode==.
drop if ID ==""
drop if edate_int==.
drop if year==2010
save BRFSdata, replace

*****merges (except for cbp********
merge statecode year using costpack, sort uniqusing _merge(merge_pack)
merge statecode year using spending, sort uniqusing _merge(merge_spending)
drop if merge_spending==1
drop if year<2001
merge statecode year using state_beer_annual, sort uniqusing _merge(merge_beer)
replace beer = (6.923333 + 7.18)/2 if (statecode==50 & year==2002)
replace beer = (6.70333 + 6.76)/2 if (statecode==33 & year==2002)
drop if year<2001
replace merge_beer = 3 if (statecode==50 & year==2002)
replace merge_beer = 3 if (statecode==33 & year==2002)
**** lose 23,803 out of 1122291
merge statecode year using state_composite_annual, sort uniqusing _merge(merge_composite)
replace composite_index = (104.4+113.4667)/2 if (statecode==50 & year==2002)
replace composite_index = (104.5 + 105.6)/2 if (statecode==33 & year==2002)
replace merge_composite = 3 if (statecode==50 & year==2002)
replace merge_composite = 3 if (statecode==33 & year==2002)
drop if year<2001

****price adjustments

* gen cpi09 = 82.52 if year==2001
* replace cpi09 = 83.83 if year==2002
* replace cpi09 = 85.76 if year==2003
* replace cpi09 = 88.05 if year==2004
* replace cpi09 = 91.01 if year==2005
* replace cpi09 = 93.94 if year==2006
* replace cpi09 = 96.64 if year==2007
* replace cpi09 = 100.33 if year==2008
* replace cpi09 = 100 if year==2009

* gen cpi09_lag = 80.26 if year==2001
* replace cpi09_lag = 82.52 if year==2002
* replace cpi09_lag  = 83.83 if year==2003
* replace cpi09_lag  = 85.76 if year==2004
* replace cpi09_lag  = 88.05 if year==2005
* replace cpi09_lag  = 91.01 if year==2006
* replace cpi09_lag  = 93.94 if year==2007
* replace cpi09_lag  = 207.34 if year==2008
* replace cpi09_lag  = 215.25 if year==2009

*gen adjcigprice = ((costpack_av/composite_index)*100)/cpi09*100
* gene adjbeer = ((beer/composite_index)*100)/cpi09*100
* gen adjfundingcap_lag = ((fundcap_lag/index_lag)*100)/cpi09_lag*100

* gen ladjcigprice = ln(adjcigprice+1)
* gen ladjbeer = ln(adjbeer+1)
* gen ladjfundinglag = ln(adjfundingcap_lag+1)


***DROPS***
egen missing_values_brfs = rowmiss(sex age_all race_all income education lfp single child smokeever drink)

egen missing_values_other = rowmiss(ladjcigprice ladjbeer ladjfundinglag)
egen missing_values_all = rowmiss(sex age_all race_all income education lfp single child smokeever drink ladjcigprice ladjfundinglag ladjbeer)

drop if missing_values_brfs>0
drop if missing_values_all>0


drop merge* composite_index index_lag cpi* missing*

cd "/Users/KateV/Desktop/data/bans_review"

sort fips statecode countycode
merge fips statecode countycode using cbsa_codes,  _merge(merge_cbsacodes)
drop if merge_cbsacodes==2

compress
save brfss&controls_nobans, replace
outsheet statecode countycode fips cbsa_code metrodiv_code using placesinbrfss.csv, comma replace
outsheet statecode countycode fips cbsa_code metrodiv_code edate_int using dates&placesinbrfss.csv, comma replace
