*** CBP DATA with CBSA & CNTY CODES ***


cd "/Users/KateV/Desktop/Honors_Final/CBP"
set mo off

*** CBP ***
forvalues x = 2000(1)2009 {
	insheet using cbp`x'co.txt, clear
	compress
	keep fipstate fipscty naics est emp
	gen fips = fipstate*1000 + fipscty
	gen year = `x'
	keep if (naics == "------" |naics=="31----"|naics=="311///"|naics=="312///"| naics=="3121//"| naics=="31212/"| naics=="312120"|naics =="31213/"| naics=="312130"| naics=="31214/"| naics=="312140"| naics=="3122//"| naics=="31221/"| naics=="312210"| naics=="31222/"| naics=="312221"| naics=="312229"| naics=="71----"| naics=="72----"|naics=="722///"|naics=="7221//"|naics=="72211/"|naics=="722110"|naics=="722213" | naics=="7224//"|	naics=="72241/" | naics=="722410" | naics=="51----"|naics=="52----" | naics=="53----"| naics=="54----" | naics=="55----" | naics=="56----"| naics=="62----")
	sort fips naics
	save cbp`x', replace
	sort fips
	
gen est_total = est if naics == "------"
by fips: carryforward est_total, replace

gen mnfg = est if naics == "31----"
sort fips mnfg
by fips: carryforward mnfg, replace  


gen foodmnfg = est if naics =="311///"
sort fips foodmnfg
by fips: carryforward foodmnfg, replace 

gen bevtobmnfg = est if naics =="312///"
by fips: carryforward bevtobmnfg, replace 

gen bevmnfg = est if naics =="3121//"
by fips: carryforward bevmnfg, replace 

gen brewerya = est if naics =="31212/"
by fips: carryforward brewerya, replace

gen winerya = est if naics == "31213/"
sort fips winerya
by fips: carryforward winerya, replace

gen distila = est if naics =="31214/"
sort fips distila
by fips: carryforward distila, replace

gen tobmnfg = est if naics =="3122//"
sort fips tobmnfg
by fips: carryforward tobmnfg, replace 

gen information = est if naics=="51----"
sort fips information
by fips: carryforward information, replace 

gen finance = est if naics=="52----" 
sort fips finance
by fips: carryforward finance, replace 

gen realestate = est if  naics=="53----"
sort fips realestate
by fips: carryforward realestate, replace


gen professional = est if naics=="54----" 
sort fips professional
by fips: carryforward professional, replace

gen management = est if naics=="55----" 
sort fips management
by fips: carryforward management, replace 



gen admin = est if naics=="56----"
sort fips admin
by fips: carryforward admin, replace 


gen healthcare = est if naics=="62----"
sort fips healthcare
by fips: carryforward healthcare, replace

gen fooddrink = est if naics == "722///"
sort fips fooddrink
by fips: carryforward fooddrink, replace 

gen resta = est if naics=="7221//"
sort fips resta
by fips: carryforward resta, replace 

gen restb = est if naics =="72211/"
sort fips restb
by fips: carryforward restb, replace 

gen restc = est if naics =="722110"
sort fips restc
by fips: carryforward restc, replace 

gen bara = est if naics=="7224//"
sort fips bara
by fips: carryforward bara, replace 

gen barb = est if naics=="72241/"
sort fips barb
by fips: carryforward barb, replace 

gen barc = est if naics =="722410"
sort fips barc
by fips: carryforward barc, replace 

mvencode mnfg foodmnfg bevtobmnfg bevmnfg brewerya  winerya  distila  tobmnfg   fooddrink resta restb restc bara barb barc, mv(0)
save, replace
	}
	
use cbp2000, clear
replace fipscty = 86 if fips==12025
replace fips = 12086 if fips==12025
forvalues x=2001(1)2009 {
	append using cbp`x'
	}

cd "/Users/KateV/Desktop/data/bans_review"
	
save cbp_all, replace	
replace fips = 12086 if fips==12025
replace fipscty = 86 if fips==12086
replace fips = 51005 if fips==51560
replace fipscty = 5 if fips==51005
replace fips = 11001 if fips==11999
replace fipscty = 1 if fips==11001

collapse est_total mnfg professional management admin healthcare realestate foodmnfg bevtobmnfg bevmnfg brewerya  winerya  distila  tobmnfg   fooddrink resta restb restc bara barb barc information finance , by(fipstate fipscty fips year)
save cbp_collapsed_cnty, replace

gen bevtob_pct_cnty = bevtobmnfg/est_total*100
gen bev_pct_cnty = bevmnfg/est_total*100
gen tob_pct_cnty = tobmnfg/est_total*100

gen fooddrink_pct_cnty = fooddrink/est_total*100
gen rest_pct_cnty = resta/est_total*100
gen bar_pct_cnty = bara/est_total*100

gen info_pct = information/est_total*100
gen finance_pct = finance/est_total*100
gen realestate_pct = realestate/est_total*100
gen professional_pct = professional/est_total*100
gen management_pct = management/est_total*100
gen admin_pct = admin/est_total*100
gen healthcare_pct = healthcare/est_total*100

egen indoorwork_mnfg = rowtotal(information finance  professional  management  admin  healthcare  mnfg)

gen indoorwork_pct_cnty = indoorwork_mnfg/est_total*100

rename fipstate state
rename fipscty county

drop if county==999

sort fips year

merge fips year using msadata, sort _merge(merge_cbsa)

drop if state==2

save cbp_merged, replace

keep state county fips year est_total resta bara rest_pct_cnty bar_pct_cnty indoorwork_pct_cnty cbsa_code metrodiv_code  stfips cnty  indoorwork_mnfg
save cbp_merged_short, replace

**** calculations ****


bysort cbsa_code metrodiv_code year: egen est_total_cbsa = total(est_total) if cbsa_code~=.
bysort cbsa_code metrodiv_code year: egen resta_cbsa = total(resta) if cbsa_code~=.
bysort cbsa_code metrodiv_code year: egen bara_cbsa = total(bara) if cbsa_code~=.
bysort cbsa_code metrodiv_code year: egen indoorwork_cbsa = total(indoorwork_mnfg) if cbsa_code~=.

gen rest_pct_cbsa = resta_cbsa/est_total_cbsa*100
gen bar_pct_cbsa = bara_cbsa/est_total_cbsa*100
gen indoorwork_pct_cbsa = indoorwork_cbsa/est_total_cbsa*100

drop if county==.
rename state statecode
rename county countycode
drop est_total* resta* bara* indoorwork_mnfg  stfips cnty    indoorwork_cbsa

sort statecode countycode fips cbsa_code metrodiv_code year
save cbp_data, replace
