**** MAP PROBABILITIES ****

***county codes***
use geocodes, clear
keep if sumlev==50
keep fips
save fipslist, replace

****cbsa codes***
use cbsacntypop_wide, clear
keep cbsa_code metrodiv_code fips
merge fips using fipslist, sort _merge(merge_fips)
gen rural = (cbsa_code==.)
gen statecode = floor(fips/1000)
sort statecode
merge statecode using statebans, uniqusing _merge(merge_state)
sort fips
merge fips using wholecountybans, uniqusing _merge(merge_cnty)
replace wcworkban_date = . if (wcworkban_date>=stateworkban_date & wcworkban_date~=.)
replace wcrestban_date = . if (wcrestban_date>=staterestban_date & wcrestban_date~=.)
replace wcbarban_date = . if (wcbarban_date>=statebarban_date & wcbarban_date~=.)
foreach b in work bar rest {

gen sq`b' = quarter(state`b'ban_date)
gen sy`b' = year(state`b'ban_date)
gen wq`b' = quarter(wc`b'ban_date)
gen wy`b' = year(wc`b'ban_date)

gen yqstate`b' = yq(sy`b', sq`b')
gen yqw`b' = yq(wy`b', wq`b')
}

sort cbsa_code metrodiv_code fips
save cbsalist, replace

***set up probabilities***

foreach b in work  bar rest {
		use cbsa`b'_probs_short, clear
		gen quarter = quarter(date)
		gen yqdate = yq(year, quarter)
		gen map1 = (yqdate==164)
		gen map2 = (yqdate==180 | yqdate==181)
		gen map3 = (year==2009)
		save cbsa`b'mapall, replace
		
			foreach var in map1 map2 map3 {
				drop if `var'==0
				bysort cbsa_code metrodiv_code: egen maxdate = max(date)
				drop if date<maxdate
				merge cbsa_code metrodiv_code using cbsalist, sort uniqmaster
				keep cbsa_code metrodiv_code fips rural cbsa`b'_prob state`b'ban_date wc`b'ban_date yqstate`b' yqw`b'
				save cbsa`b'`var', replace
				use cbsa`b'mapall
				}
}				


foreach b in work  bar rest {
		use cnty`b'_probs_short, clear
		gen quarter = quarter(date)
		gen yqdate = yq(year, quarter)
		gen map1 = (yqdate==164)
		gen map2 = (yqdate==180 | yqdate==181)
		gen map3 = (year==2009)
		save cnty`b'mapall, replace
		
			foreach var in map1 map2 map3 {
				drop if `var'==0
				bysort fips: egen maxdate = max(date)
				drop if date<maxdate
				merge fips using cbsa`b'`var', sort uniqmaster
				keep fips year cnty`b'_prob yqdate rural yqstate`b' yqw`b' cbsa`b'_prob
				egen mapdate = max(yqdate)
				gen probability = cbsa`b'_prob
				replace probability = cnty`b'_prob if rural==1
				replace probability = 1 if (rural==1 & mapdate>=yqw`b')
				replace probability = 1 if (rural==1 & mapdate>=yqstate`b')
				replace probability = 0 if probability==.
				sort fips
				save `b'`var', replace
				outsheet fips probability using `b'`var'.csv, comma replace											
				use cnty`b'mapall
				}
}


		
			
