***GETTING URBAN/RURAL DESIGNATION TO SET UP CITY BANS ***

** POPULATION DATA

**cbsa counties: from cure for the common code***

insheet using cbsa_county_pop.csv, clear
rename cbsa cbsa_code
rename metrodiv metrodiv_code
rename fipco fips
rename fipsstate stfips

rename totalpopestjuly00 cbsacntypop2000
rename totalpopestjuly01 cbsacntypop2001
rename totalpopestjuly02 cbsacntypop2002
rename totalpopestjuly03 cbsacntypop2003
rename totalpopestjuly04 cbsacntypop2004
rename totalpopestjuly05 cbsacntypop2005
rename totalpopestjuly06 cbsacntypop2006
rename totalpopestjuly07 cbsacntypop2007
rename totalpopestjuly08 cbsacntypop2008
rename totalpopestjuly09 cbsacntypop2009

drop if cbsa_code==.
drop if stfips>56
drop if stfips==2

save cbsacntypop_wide, replace

***cbsa state pops ***
collapse (sum) cbsacntypop*, by(cbsa_code metrodiv_code stfip)

forvalues y = 2000(1)2009 {
rename cbsacntypop`y' cbsastatepop`y'
}
save cbsastatepop_wide, replace

***cbsa pops ***
collapse (sum) cbsastatepop*, by(cbsa_code metrodiv_code)
forvalues y = 2000(1)2009 {
rename cbsastatepop`y' msapop`y'
}
save cbsa_pop_wide, replace
reshape long msapop, i(cbsa_code metrodiv_code) j(year)
save cbsa_pop, replace

***RESHAPES AND MERGES
use cbsacntypop_wide, clear
reshape long cbsacntypop, i(cbsa_code metrodiv_code fips) j(year)
sort cbsa_code metrodiv_code stfips year
save cbsacntypop, replace
keep cbsa_code metrodiv_code fips stfips cnty
rename stfips statecode
rename cnty countycode
egen cntytag = tag(cbsa_code metrodiv_code fips)
bysort cbsa_code metrodiv_code: egen cntytotal = total(cntytag)
gen multicnty_cbsa = (cntytotal>1)
egen sttag = tag(cbsa_code metrodiv_code statecode)
bysort cbsa_code metrodiv_code: egen sttotal = total(sttag)
gen multistate_cbsa = (sttotal>1)
sort fips statecode countycode
save cbsa_codes, replace

use cbsastatepop_wide, clear
reshape long cbsastatepop, i(cbsa_code metrodiv_code stfips) j(year)
sort cbsa_code metrodiv_code year
save cbsastatepop, replace

use cbsa_pop, clear
merge cbsa_code metrodiv_code year using cbsastatepop, sort uniqmaster _merge(merge_state)
sort cbsa_code metrodiv_code stfips year
merge cbsa_code metrodiv_code stfips year using cbsacntypop, uniqmaster _merge(merge_county)
sort fips year
save msadata, replace

